#pragma once

#include <string>
#include <vector>
#include <map>
#include <set>

////////////////////////////////////////////////////////////////////////
// CHK [h
////////////////////////////////////////////////////////////////////////

// CHK [hɓ͂łő啶
#define NUM_CHK_WORD_MAX	512

class ChkWord {
public:
	// CHK [h̎
	enum WordType { ChkwAll = 0, ChkwSubject = 1, ChkwFromname = 2 };

public:
	// RXgN^
	ChkWord();
	// RXgN^
	ChkWord(const char* chkword, const WordType wdType, const bool bRegex, const bool bCase);

public:
	// }b`邩
	bool IsMatch(const char* subject, const char* fromname);

public:
	// CHK [h
	std::string& GetWord();
	// CHK [h̎
	WordType GetWordType();
	// K\
	bool IsRegex();
	// p召
	bool IsCase();

private:
	// CHK [h
	std::string m_word;
	// CHK [h̎
	WordType m_wordType;
	// K\
	bool m_bRegex;
	// p召
	bool m_bCase;
};

////////////////////////////////////////////////////////////////////////
// CHK [hꗗ
////////////////////////////////////////////////////////////////////////

class ChkWordList {
public:
	// RXgN^
	ChkWordList();

public:
	// CHK [hɃ}b`̂邩𓾂
	bool IsMatch(const char* subject, const char* fromname);
	// CHK [h݂邩𓾂
	bool IsExist(const char* chkword);
	// CHK [h̏𓾂
	std::map<std::string, ChkWord>& GetChkWordList();
	// CHK [ȟ𓾂
	int Count();
	// CHK [hǉ
	void Add(const char* chkword, const ChkWord::WordType wdType, const bool bRegex, const bool bCase);
	// 폜
	void Delete(const char* chkword);
	// XV
	void Update(const char* chkword, const ChkWord::WordType wdType, const bool bRegex, const bool bCase);
	// ǉ܂͍XV
	void AddOrUpdate(const char* chkword, const ChkWord::WordType wdType, const bool bRegex, const bool bCase);
	// SNA
	void ClearAll();
	// C|[g
	void Import(const char* filepath);
	// GNX|[g
	void Export(const char* filepath);

public:
	// rp̃IuWFNgݒ肷
	void SetLockObject(CRITICAL_SECTION* pcsChkWordList);

private:
	// rp
	CRITICAL_SECTION* m_pcsChkWordList;

private:
	// CHK [ḧꗗ
	std::map<std::string, ChkWord> m_chkWordList;

//
// \[ĝ߂̎
//
public:
	// \[g鍀
	enum SortKey { SortChkwType = 0, SortChkwWord = 1, SortChkwRegex = 2, SortChkwCase = 3 };

public:
	// \[gs
	void Sort();
	// \[gL[擾/ݒ
	SortKey GetSortKey();
	void SetSortKey(SortKey sortKey);
	// ǂ擾/ݒ
	bool IsAscending();
	void SetAscending(bool bAscending);
	// n Ԗڂ CHK [hԂ
	ChkWord& GetAt(int index);
	// w CHK [h̃CfbNXԂ
	int GetIndex(const char* chkword);
	// n Ԗڂ CHK [h폜
	bool DeleteAt(int index);

private:
	// \[gL[
	SortKey m_sortKey;
	// ǂ
	bool m_bAscending;
	// \[g̃L[ێ
	std::vector<std::string> m_sortedChkWord;
	// ftHgp̒l(ʏ͎gpȂ)
	ChkWord m_emptyChkw;
};

