#include "stdafx.h"

#include <shtypes.h>
#include <shlobj.h>
#include <shlwapi.h>
#include <mbctype.h>
#include <mbstring.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <stdlib.h>

#include <cstdarg>
#include <regex>

#include "BkCommon.h"
#include "Logger.h"
#include "Util.h"

////////////////////////////////////////////////////////////////////////
// [eBeBQ
////////////////////////////////////////////////////////////////////////

//----------------------------------------------------------------------
// O̎w蕶Q
//----------------------------------------------------------------------

std::string Util::Trim(std::string& str, const char* removechs)
{
	const char* pStrBegin = str.c_str();

	const char* pStr = pStrBegin;
	int beginpos = -1;

	while (pStr && *pStr) {
		int mbType = _mbsbtype((unsigned char*) pStr, 0);

		if (!Util::IsExistChs(pStr, mbType, removechs)) {
			beginpos = pStr - pStrBegin;
			break;
		}

		pStr = (char*) _mbsinc((unsigned char*) pStr);
	}

	if (beginpos == -1) {
		return "";
	}

	pStr = pStrBegin + beginpos;
	int endpos = -1;

	while (pStr && *pStr) {
		int mbType = _mbsbtype((unsigned char*) pStr, 0);

		if (!Util::IsExistChs(pStr, mbType, removechs)) {
			endpos = pStr - pStrBegin;
		}

		pStr = (char*) _mbsinc((unsigned char*) pStr);
	}

	if (endpos == -1) {
		return str.substr(beginpos);
	} else {
		pStr = pStrBegin + endpos;
		if (_mbsbtype((unsigned char*) pStr, 0) == _MBC_LEAD) {
			endpos += 2;
		} else {
			endpos += 1;
		}

		return str.substr(beginpos, endpos - beginpos);
	}
}

std::string Util::Trim(const char* pstr, const char* removechs)
{
	if (!pstr) {
		return "";
	}

	std::string str = pstr;
	return Trim(str, removechs);
}

//----------------------------------------------------------------------
// Ԃ
//----------------------------------------------------------------------

bool Util::IsSameChr(const char* pStr1, int mbType1, const char* pStr2, int mbType2)
{
	bool result = false;

	if (mbType1 == mbType2) {
		switch (mbType1) {
		case _MBC_LEAD:
			if (*pStr1 == *pStr2 && *(pStr1+1) == *(pStr2+1)) {
				result = true;
			}
			break;

		default:
		////case _MBC_SINGLE:
		////case _MBC_ILLEGAL:	// ^uLȂ
			if (*pStr1 == *pStr2) {
				result = true;
			}
			break;
		}
	}

	return result;
}

//----------------------------------------------------------------------
// w̕Qɑ݂邩Ԃ
//----------------------------------------------------------------------

bool Util::IsExistChs(const char* pStr, int mbType, const char* chs)
{
	const char* pBeginChs = chs;

	while (pBeginChs && *pBeginChs) {
		int mbTypeChs = _mbsbtype((unsigned char*) pBeginChs, 0);
		if (Util::IsSameChr(pStr, mbType, pBeginChs, mbTypeChs)) {
			return true;
		}

		pBeginChs = (char*) _mbsinc((unsigned char*) pBeginChs);
	}

	return false;
}

//----------------------------------------------------------------------
// w̕ŏIĂ邩ǂԂ
//----------------------------------------------------------------------

bool Util::EndsWith(std::string& targetStr, char* pstr)
{
	int pos = targetStr.rfind(pstr);
	if (pos == std::string::npos) {
		return false;
	}

	if (pos + strlen(pstr) < targetStr.length()) {
		return false;
	}

	return true;
}

//----------------------------------------------------------------------
// pX؂ŏIĂ邩ǂԂ
//----------------------------------------------------------------------

bool Util::EndsWithPathDelimiter(std::string& targetStr)
{
	const char* pTarget = targetStr.c_str();

	bool result = false;
	char* wp = (char*) _mbsrchr((unsigned char*) pTarget, '\\');
	if (wp && wp == (pTarget + (targetStr.length() - 1))) {
		result = true;
	}

	return result;
}

//----------------------------------------------------------------------
// u
//----------------------------------------------------------------------

void Util::Replace(std::string& targetStr, std::string strOld, std::string strNew)
{
	if (targetStr.length() == 0) {
		return;
	}

	if (strOld.length() == 0) {
		return;
	}

	int pos = 0;
	while ((pos = targetStr.find(strOld, pos)) != std::string::npos) {
		targetStr.replace(pos, strOld.length(), strNew);
		pos += strNew.length();
	}
}

//----------------------------------------------------------------------
// sR[h CR + LF ɓꂷ
//----------------------------------------------------------------------

void Util::SameCrLf(std::string& targetStr)
{
	// \r\n -> \r\n, \r -> \r\n, \n -> \r\n
	Util::Replace(targetStr, "\r\n", "\n");
	Util::Replace(targetStr, "\r", "\n");
	Util::Replace(targetStr, "\n", "\r\n");
}

//----------------------------------------------------------------------
// wb_tB[hɑΉwb_tB[hAwb_tB[h{fB̈ʒuԂ
//----------------------------------------------------------------------

bool Util::GetHeaderFieldPosition(const char* pMail, const char* pHeaderFieldName, int* pHeaderFieldNameStart, int* pHeaderFieldNameEnd, int* pHeaderFieldBodyStart, int* pHeaderFieldBodyEnd)
{
	bool result = false;

	int indexFieldNameStart = 0;
	int indexFieldNameEnd = 0;
	int indexBodyStart = 0;
	int indexBodyEnd = 0;

	if (!pMail) {
		return false;
	}

	if (!pHeaderFieldName) {
		return false;
	}

	if (!pHeaderFieldNameStart || !pHeaderFieldNameEnd || !pHeaderFieldBodyStart || !pHeaderFieldBodyEnd) {
		return false;
	}

	int headerFieldNameLength = strlen(pHeaderFieldName);
	if (headerFieldNameLength == 0) {
		return false;
	}

	const char* pItem = (char*) pMail;
	const char* pHeaderEnd = (char*) strstr(pMail, "\r\n\r\n");
	if (!pHeaderEnd) {
		return false;
	}

	// tB[hT
	while (pItem) {
		pItem = __stristr((char*) pItem, (char*) pHeaderFieldName);
		if (!pItem) {
			// ݂Ȃ
			break;
		}

		if (pMail == pItem) {
			// 擪Ō
		} else if (pMail + 2 <= pItem) {
			// 擪łȂ΁AO "\r\n" ݂΁AtB[ĥ͂܂Ƃ݂ȂB
			if (strncmp(pItem - 2, "\r\n", 2) != 0) {
				++pItem;
				continue;
			}
		} else {
			++pItem;
			continue;
		}

		pItem += headerFieldNameLength;
		if (*pItem != ':') {
			continue;
		}

		if (pHeaderEnd <= pItem) {
			// Ïʒu𒴂Ăꍇ́AtB[hł͂Ȃ
			pItem = 0;
			break;
		}

		// ǂtB[hɏo炵
		indexFieldNameStart = (pItem - headerFieldNameLength) - pMail;
		indexFieldNameEnd = pItem - pMail;

		++pItem;
		while (*pItem == ' ' || *pItem == '\t') {
			++pItem;
		}

		break;
	}

	// tB[h{fBT
	if (pItem) {
		indexBodyStart = pItem - pMail;
		const char* pItemStart = pItem;

		for (;;) {
			pItem = strstr(pItem, "\r\n");
			if (!pItem) {
				break;
			}

			pItem += 2;
			if ((*pItem != ' ' && *pItem != '\t') || strncmp(pItem, "\r\n", 2) == 0) {
				indexBodyEnd = pItem - pMail;

				int bodyLengthWithoutCRLF = pItem - 2 - pItemStart;

				*pHeaderFieldNameStart = indexFieldNameStart;
				*pHeaderFieldNameEnd = indexFieldNameEnd;
				*pHeaderFieldBodyStart = indexBodyStart;
				*pHeaderFieldBodyEnd = indexBodyEnd;

				result = true;

				break;
			}
		}
	}

	return result;
}

//----------------------------------------------------------------------
// wb_tB[hɑΉwb_tB[h{fBԂ
//----------------------------------------------------------------------

std::string Util::GetHeaderFieldBody(const char* pMail, const char* pHeaderFieldName, bool* pbFind)
{
	std::string result = "";

	int indexFieldNameStart = 0;
	int indexFieldNameEnd = 0;
	int indexBodyStart = 0;
	int indexBodyEnd = 0;

	bool bFind = GetHeaderFieldPosition(pMail, pHeaderFieldName, &indexFieldNameStart, &indexFieldNameEnd, &indexBodyStart, &indexBodyEnd);
	if (bFind) {
		int indexBodyEndWithoutCRLF = indexBodyEnd - 2;
		result = std::string(&pMail[indexBodyStart], indexBodyEndWithoutCRLF - indexBodyStart);
	}
	if (pbFind) {
		*pbFind = bFind;
	}

	return result;
}

//----------------------------------------------------------------------
//  True, False  bool l𓾂
//----------------------------------------------------------------------

bool Util::GetBoolean(std::string& itemValue, bool defaultValue)
{
	if (_stricmp(itemValue.c_str(), "True") == 0) {
		return true;
	} else if (_stricmp(itemValue.c_str(), "False") == 0) {
		return false;
	}

	return defaultValue;
}

//----------------------------------------------------------------------
// bool l當 True, False 𓾂
//----------------------------------------------------------------------

std::string Util::GetBooleanStr(bool value)
{
	return (value) ? "True" : "False";
}

//----------------------------------------------------------------------
// HANDLE ɏ
//----------------------------------------------------------------------

BOOL Util::WriteToFile(HANDLE hHandle, const char* lpBuffer, DWORD nNumberOfBytesToWrite)
{
#define __FUNCNAME__ "WriteToFile()"
	char* pcfnname = "";

	LOGGING_DEBUG("begin.");

	DWORD total = 0;
	BOOL result = TRUE;
	DWORD writeBytes;

	while (total < nNumberOfBytesToWrite) {
		pcfnname = "WriteFile()";

		writeBytes = 0;
		if (!WriteFile(hHandle, &lpBuffer[total], nNumberOfBytesToWrite - total, &writeBytes, 0)) {
			LOGGING_ERROR("%s: LastError: [%lu].", pcfnname, GetLastError());
			result = FALSE;
			break;
		}
		//LOGGING_DEBUG("[%d] byte(s) written.", writeBytes);

		total += writeBytes;
	}
	LOGGING_DEBUG(nNumberOfBytesToWrite, lpBuffer, "[%d]/[%d] byte(s) written.", total, nNumberOfBytesToWrite);

	LOGGING_DEBUG("end.");

	return result;

#undef __FUNCNAME__
}

//----------------------------------------------------------------------
// 񂪉p݂̂ō\Ă邩Ԃ
//----------------------------------------------------------------------

bool Util::IsAlnumString(const char* str)
{
	const char* pStr = str;

	while (pStr && *pStr) {
		int mbType = _mbsbtype((unsigned char*) pStr, 0);
		if (mbType != _MBC_SINGLE) {
			return false;
		}

		if (!isalnum(*pStr)) {
			return false;
		}

		pStr = (char*) _mbsinc((unsigned char*) pStr);
	}

	return true;
}

//----------------------------------------------------------------------
// sapm \wb_ǉV[f[^쐬
//----------------------------------------------------------------------

bool Util::AddSpamHeader(const char* pMail, int mailLength, const std::string* pSpamHeaderFieldName, const std::string* pSpamHeader, std::vector<char>* pMailNew)
{
	bool result = false;

	if (!pMail) {
		return false;
	}

	if (mailLength <= 0) {
		return false;
	}

	if (!pSpamHeaderFieldName) {
		return false;
	}

	int spamHeaderFieldNameLength = pSpamHeaderFieldName->length();

	if (spamHeaderFieldNameLength == 0) {
		return false;
	}

	if (!pSpamHeader) {
		return false;
	}

	int spamHeaderLength = pSpamHeader->length();

	if (spamHeaderLength == 0) {
		return false;
	}

	if (!pMailNew) {
		return false;
	}

	bool bFind = false;
	GetHeaderFieldBody(pMail, pSpamHeaderFieldName->c_str(), &bFind);
	if (!bFind) {
		pMailNew->resize(spamHeaderLength + mailLength + 1);
		strcpy(&(*pMailNew)[spamHeaderLength], pMail);
		memcpy(&(*pMailNew)[0], pSpamHeader->c_str(), spamHeaderLength);

		result = true;
	}

	return result;
}

//----------------------------------------------------------------------
// spam \wb_폜V[f[^쐬
//----------------------------------------------------------------------

bool Util::RemoveSpamHeader(const char* pMail, int mailLength, const std::string* pSpamHeaderFieldName, std::vector<char>* pMailNew)
{
	bool result = false;

	if (!pMail) {
		return false;
	}

	if (mailLength <= 0) {
		return false;
	}

	if (!pSpamHeaderFieldName) {
		return false;
	}

	int spamHeaderFieldNameLength = pSpamHeaderFieldName->length();

	if (spamHeaderFieldNameLength == 0) {
		return false;
	}

	if (!pMailNew) {
		return false;
	}


	int indexFieldNameStart = 0;
	int indexFieldNameEnd = 0;
	int indexBodyStart = 0;
	int indexBodyEnd = 0;

	bool bFind = GetHeaderFieldPosition(pMail, pSpamHeaderFieldName->c_str(), &indexFieldNameStart, &indexFieldNameEnd, &indexBodyStart, &indexBodyEnd);
	if (bFind) {
		int spamHeaderLength = indexBodyEnd - indexFieldNameStart;
		if (0 < spamHeaderLength) {
			int afterMailLength = mailLength - spamHeaderLength;
			pMailNew->resize(afterMailLength + 1);
			memcpy(&(*pMailNew)[0], &pMail[0], indexFieldNameStart);
			strcpy((char*) &(*pMailNew)[indexFieldNameStart], &pMail[indexBodyEnd]);

			result = true;
		}
	}

	return result;
}

//----------------------------------------------------------------------
// w̃EBhEeEBhE̒Ɉړ
//----------------------------------------------------------------------

void Util::CenterWindow(HWND hWndParent, HWND hWnd)
{
	RECT rtParent = { 0 };
	RECT rtPropSheet = { 0 };

	GetWindowRect(hWndParent, &rtParent);
	GetWindowRect(hWnd, &rtPropSheet);

	int x = (rtParent.left + (rtParent.right - rtParent.left) / 2) - ((rtPropSheet.right - rtPropSheet.left) / 2);
	int y = (rtParent.top + (rtParent.bottom - rtParent.top) / 2) - ((rtPropSheet.bottom - rtPropSheet.top) / 2);

	SetWindowPos(hWnd, 0, x, y, 0, 0, SWP_NOSIZE | SWP_NOZORDER | SWP_NOACTIVATE);
}

//----------------------------------------------------------------------
// Becky! ̃tH_ƂĐʂ
//----------------------------------------------------------------------

BOOL Util::IsValidBeckyFolder(std::string folderId)
{
	// XXXXXXXX.mb\XXX\ ̂悤Ȍ`̃tH_nĂ邱ƂOƂ
	const char* pFolderId = folderId.c_str();

	int bscount = 0;
	unsigned char* pbs = (unsigned char*) pFolderId;

	do {
		pbs = _mbschr(pbs, '\\');
		if (pbs) {
			++pbs;
			++bscount;
		}

	} while (pbs);

	return (bscount <= 1) ? FALSE : TRUE;
}

//----------------------------------------------------------------------
// '@' ȍ~̕ԂBȂꍇ͋󕶎Ԃ
//----------------------------------------------------------------------

std::string Util::GetAtNext(const char* email)
{
	const char* pAt = strchr(email, '@');
	if (!pAt) {
		return "";
	}
	++pAt;

	std::string domain = Util::Trim(pAt);

	return domain;
}

//----------------------------------------------------------------------
// RRg[o[W 6 ȍ~gpĂ邩Ԃ
//----------------------------------------------------------------------

bool Util::IsCommonCtrlVersion6()
{
	bool isCommonCtrlVersion6 = false;

	//
	// comctl32.dll [hAo[WQƂA6 ȍ~𔻒fB
	//
	HINSTANCE commonCtrlDll = LoadLibrary("comctl32.dll");
	if (commonCtrlDll) {

		DLLGETVERSIONPROC pDllGetVersion;

		// o[WԂ֐擾ČĂяoB
		pDllGetVersion = (DLLGETVERSIONPROC) GetProcAddress(commonCtrlDll, "DllGetVersion");
		if (pDllGetVersion)  {
			DLLVERSIONINFO dvi;

			ZeroMemory(&dvi, sizeof(dvi));
			dvi.cbSize = sizeof(DLLVERSIONINFO);

			// o[W𓾂B
			(*pDllGetVersion)(&dvi);

			isCommonCtrlVersion6 = (6 <= dvi.dwMajorVersion) ? true : false;
		}
		FreeLibrary(commonCtrlDll);
	}

	return isCommonCtrlVersion6;
}

//----------------------------------------------------------------------
// EBhEe[}̑
//----------------------------------------------------------------------

typedef HRESULT (WINAPI* PF_SetWindowTheme)(HWND hwnd, LPCWSTR pszSubAppName, LPCWSTR pszSubIdList);

HRESULT Util::SetWindowTheme(HWND hWnd, LPCWSTR pszSubAppName, LPCWSTR pszSubIdList)
{
	HRESULT hr = E_FAIL;

	bool applyStyle = IsOverVersion5_1();
	if (!applyStyle) {
		return hr;
	}

	HMODULE hModTheme = LoadLibrary("uxtheme.dll");
	if (!hModTheme) {
		return hr;
	}

	do {
		PF_SetWindowTheme setWindowTheme = (PF_SetWindowTheme) GetProcAddress(hModTheme, "SetWindowTheme");
		if (!setWindowTheme) {
			break;
		}

		hr = setWindowTheme(hWnd, pszSubAppName, pszSubIdList);

	} while (false);

	FreeLibrary(hModTheme);

	return hr;
}

//----------------------------------------------------------------------
// EBhẼo[W𓾂
//----------------------------------------------------------------------

BOOL Util::GetVersionEx(LPOSVERSIONINFO lpVersionInfo)
{
	ZeroMemory(lpVersionInfo, sizeof(*lpVersionInfo));
	lpVersionInfo->dwOSVersionInfoSize = sizeof(*lpVersionInfo);

	return ::GetVersionEx(lpVersionInfo);
}

//----------------------------------------------------------------------
// EBhẼo[W 5.1 zĂ邩Ԃ
//----------------------------------------------------------------------

bool Util::IsOverVersion5_1()
{
	bool bOverVersion5_1 = false;

	OSVERSIONINFO osVer;
	BOOL rc = Util::GetVersionEx(&osVer);
	if (rc) {
		if (6 <= osVer.dwMajorVersion) {
			// Vista ȍ~
			bOverVersion5_1 = true;
		} else if (5 <= osVer.dwMajorVersion && 1 <= osVer.dwMinorVersion) {
			// XP, Server 2003
			bOverVersion5_1 = true;
		}
	}

	return bOverVersion5_1;
}

//----------------------------------------------------------------------
// bsfilter pł邩Ԃ
//----------------------------------------------------------------------

bool Util::IsBsfilterInstalled(ExecBsfilterScriptProfile &execBsScriptProfile, const char* bsfilterPath, const char* iconvPath, const char* bsfilterScriptPath)
{
	struct _stat fsts;

	if (execBsScriptProfile.GetUseBsfilterScript()) {
		if (_stat(bsfilterScriptPath, &fsts) == 0 && fsts.st_mode & _S_IFREG) {
		} else {
			return false;
		}

		if (_stat(execBsScriptProfile.GetRubyModulePath().c_str(), &fsts) == 0 && fsts.st_mode & _S_IFREG) {
		} else {
			return false;
		}

		return true;

	} else {

		if (_stat(bsfilterPath, &fsts) == 0 && fsts.st_mode & _S_IFREG) {
		} else {
			return false;
		}

		if (_stat(iconvPath, &fsts) == 0 && fsts.st_mode & _S_IFREG) {
		} else {
			return false;
		}

		return true;
	}
}

//----------------------------------------------------------------------
// 𕪊
//----------------------------------------------------------------------

std::vector<std::string> Util::Split(const std::string &str, char delim)
{
	std::vector<std::string> result;
	size_t currentpos = 0;
	size_t foundpos;

	while((foundpos = str.find_first_of(delim, currentpos)) != std::string::npos){
		result.push_back(str.substr(currentpos, foundpos - currentpos));
		currentpos = foundpos + 1;
	}
	result.push_back(str.substr(currentpos, str.size() - currentpos));

	return result;
}

//----------------------------------------------------------------------
// Chɕϊ
//----------------------------------------------------------------------

std::wstring Util::ToWideString(const char* source)
{
	// Kvȗ̈mۂ
	size_t length = mbstowcs(0, source, 0);
	wchar_t* buffer = (wchar_t*) _malloca(sizeof(wchar_t) * (length + 1));

	// ϊ
	size_t convedLength = mbstowcs(buffer, source, length + 1);
	buffer[length] = L'\0';

	std::wstring result = buffer;

	// ϊɎgp̈
	_freea(buffer);

	return result;
}

//----------------------------------------------------------------------
// MBCS ɕϊ
//----------------------------------------------------------------------

std::string Util::ToNarrowString(const wchar_t* source)
{
	size_t length = wcstombs(0, source, 0);
	char* buffer = (char*) _malloca(sizeof(char) * (length + 1));

	size_t convedLength = wcstombs(buffer, source, length + 1);
	buffer[length] = '\0';

	std::string result = buffer;

	_freea(buffer);

	return result;
}

//----------------------------------------------------------------------
// K\Ń}b`邩
//----------------------------------------------------------------------

bool Util::IsRegexMatch(const char* target, const char* pattern, bool ignoreCase, bool& bError, std::string& errorWhat)
{
	bool result = false;

	bError = false;
	errorWhat = "";

	std::wstring wtarget = ToWideString(target);
	std::wstring wpattern = ToWideString(pattern);

	try {
		std::wregex wrgx;

		if (ignoreCase) {
			std::wregex rgx(wpattern, std::regex_constants::icase);
			wrgx = rgx;
		} else {
			std::wregex rgx(wpattern);
			wrgx = rgx;
		}

		result = std::regex_search(wtarget, wrgx, std::regex_constants::match_default);

	} catch (std::regex_error& rgx_error) {
		result = false;
		bError = true;
		errorWhat = rgx_error.what();
	}

	return result;
}

//----------------------------------------------------------------------
// }b`邩
//----------------------------------------------------------------------

bool Util::IsMatch(const char* target, const char* pattern, bool isRegex, bool ignoreCase, bool& bError, std::string& errorWhat)
{
	bool result = false;

	if (isRegex) {
		result = IsRegexMatch(target, pattern, ignoreCase, bError, errorWhat);
	} else {

		if (ignoreCase) {
			unsigned char* targetBuffer = (unsigned char*) _malloca(sizeof(char) * (strlen(target) + 1));
			_mbscpy(targetBuffer, (unsigned char*) target);

			unsigned char* patternBuffer = (unsigned char*) _malloca(sizeof(char) * (strlen(pattern) + 1));
			_mbscpy(patternBuffer, (unsigned char*) pattern);

			_mbsupr(targetBuffer);
			_mbsupr(patternBuffer);

			unsigned char* psrch = _mbsstr(targetBuffer, patternBuffer);
			result = (psrch != 0);

			_freea(targetBuffer);
			_freea(patternBuffer);
		} else {
			unsigned char* psrch = _mbsstr((unsigned char*) target, (unsigned char*) pattern);
			result = (psrch != 0);
		}
	}

	return result;
}

////////////////////////////////////////////////////////////////////////
// CRITICAL_SECTION ̃bN/AbNp
////////////////////////////////////////////////////////////////////////

//----------------------------------------------------------------------
// RXgN^
//----------------------------------------------------------------------

CSLock::CSLock(CRITICAL_SECTION* pcs) :
	m_pcs(pcs)
{
	if (m_pcs) {
		EnterCriticalSection(m_pcs);
	}
}

//----------------------------------------------------------------------
// fXgN^
//----------------------------------------------------------------------

CSLock::~CSLock()
{
	if (m_pcs) {
		LeaveCriticalSection(m_pcs);
	}
}

////////////////////////////////////////////////////////////////////////
// EFCgJ[\\
////////////////////////////////////////////////////////////////////////

//----------------------------------------------------------------------
// RXgN^
//----------------------------------------------------------------------

CWaitCursor::CWaitCursor()
{
	m_hPrevCursor = SetCursor(LoadCursor(0, IDC_WAIT));
}

//----------------------------------------------------------------------
// fXgN^
//----------------------------------------------------------------------

CWaitCursor::~CWaitCursor()
{
	if (m_hPrevCursor) {
		SetCursor(m_hPrevCursor);
	}
}

//----------------------------------------------------------------------
// ɖ߂
//----------------------------------------------------------------------

void CWaitCursor::Restore()
{
	if (m_hPrevCursor) {
		SetCursor(m_hPrevCursor);
		m_hPrevCursor = 0;
	}
}

////////////////////////////////////////////////////////////////////////
// t@Co[W擾
////////////////////////////////////////////////////////////////////////

//----------------------------------------------------------------------
// RXgN^
//----------------------------------------------------------------------

CFileVersionInfo::CFileVersionInfo(HMODULE hModule) :
	m_placp(0),
	m_lenlacp(0)
{
	// W[̃pX𓾂B
	char modulePath[MAX_PATH * 4] = "";

	DWORD length = GetModuleFileName(hModule, modulePath, sizeof(modulePath));
	modulePath[length] = '\0';

	// o[W擾
	DWORD verInfoSize = GetFileVersionInfoSize(modulePath, 0);
	if (0 < verInfoSize) {
		m_verInfo.resize(verInfoSize);

		GetFileVersionInfo(modulePath, 0, (DWORD) m_verInfo.size(), &m_verInfo[0]);

		// ꂨуR[hy[Wւ̎QƂ𓾂
		VerQueryValue(&m_verInfo[0], "\\VarFileInfo\\Translation", (VOID**) &m_placp, &m_lenlacp);
	}
}


//---------------------------------------------------------------------------
// CompanyName 擾
//---------------------------------------------------------------------------

std::string CFileVersionInfo::GetCompanyName()
{
	std::string blockvalue;
	QueryValue("CompanyName", &blockvalue);
	return blockvalue;
}

//---------------------------------------------------------------------------
// ProductName 擾
//---------------------------------------------------------------------------

std::string CFileVersionInfo::GetProductName()
{
	std::string blockvalue;
	QueryValue("ProductName", &blockvalue);
	return blockvalue;
}

//----------------------------------------------------------------------
// ProductVersion 擾
//----------------------------------------------------------------------

std::string CFileVersionInfo::GetProductVersion()
{
	std::string blockvalue;
	QueryValue("ProductVersion", &blockvalue);
	return blockvalue;
}

//----------------------------------------------------------------------
// Comments 擾
//----------------------------------------------------------------------

std::string CFileVersionInfo::GetComments()
{
	std::string blockvalue;
	QueryValue("Comments", &blockvalue);
	return blockvalue;
}

//----------------------------------------------------------------------
// o[W񂩂l擾
//----------------------------------------------------------------------

BOOL CFileVersionInfo::QueryValue(char* name, std::string* value)
{
	if ((m_lenlacp / sizeof(LANGANDCODEPAGE)) <= 0 || !m_placp || m_verInfo.size() <= 0) {
		return FALSE;
	}

	char blockName[2048];
	_snprintf(blockName, sizeof(blockName),
			"\\StringFileInfo\\%04x%04x\\%s",
			m_placp->wLanguage, m_placp->wCodePage, name
		);
	FORCE_ASCIZ(blockName);

	char* blockValue = 0;
	UINT blockLen = 0;
	BOOL br = VerQueryValue(&m_verInfo[0], blockName, (VOID**) &blockValue, &blockLen);
	if (br) {
		*value = std::string(blockValue, blockLen);
		return TRUE;
	}

	return FALSE;
}

////////////////////////////////////////////////////////////////////////
// tH_IEBhE
////////////////////////////////////////////////////////////////////////

//----------------------------------------------------------------------
// IꂽpX擾
//----------------------------------------------------------------------

std::string CBrowseBeckyFolderDlg::GetFolderPath()
{
	return m_folderPath;
}

//----------------------------------------------------------------------
// \
//----------------------------------------------------------------------

int CBrowseBeckyFolderDlg::DoModal(HWND hWndOwner, char* rootFolder, char* selFolder, char* pTitle)
{
	char displayName[MAX_PATH * 4] = "";
	char folderName[MAX_PATH * 4] = "";

	CoInitializeEx(0, COINIT_APARTMENTTHREADED);

	int result = IDCANCEL;
	BOOL rc;
	HRESULT hr;

	LPSHELLFOLDER pShellFolder = 0;
	LPITEMIDLIST rootPidl = 0;
	LPITEMIDLIST pList = 0;

	do {

		hr = SHGetDesktopFolder(&pShellFolder);
		if (!SUCCEEDED(hr)) {
			break;
		}

		// [gtH_擾
		wchar_t wRootFolder[MAX_PATH * 4];
		int chCount = MultiByteToWideChar(CP_ACP, 0, rootFolder, -1, wRootFolder, sizeof(wRootFolder)/sizeof(wchar_t));
		if (chCount == 0) {
			break;
		}

		hr = pShellFolder->ParseDisplayName(0, 0, wRootFolder, 0, &rootPidl, 0);
		if (!SUCCEEDED(hr)) {
			break;
		}

		// BROWSEINFO \̂ݒ肵AtH_I\
		BROWSEINFO bi;
		ZeroMemory(&bi, sizeof(bi));

		bi.hwndOwner = hWndOwner;
		bi.pszDisplayName = displayName;
		bi.pidlRoot  = rootPidl;
		bi.lpszTitle = pTitle;
		bi.ulFlags = BIF_RETURNONLYFSDIRS;
		bi.lpfn = BrowseCallbackProc;
		bi.lParam = (LPARAM) selFolder;

		pList = SHBrowseForFolder(&bi);
		if (!pList) {
			break;
		}

		// pX𓾂
		rc = SHGetPathFromIDList(pList, folderName);
		if (!rc) {
			break;
		}

		m_folderPath = folderName;

		result = IDOK;

	} while (false);

	if (pList) { CoTaskMemFree(pList); }
	if (rootPidl) { CoTaskMemFree(rootPidl); }
	if (pShellFolder) { pShellFolder->Release(); }

	CoUninitialize();

	return result;
}

//----------------------------------------------------------------------
// R[obN֐
//----------------------------------------------------------------------

int CALLBACK CBrowseBeckyFolderDlg::BrowseCallbackProc(HWND hwnd, UINT uMsg, LPARAM lParam, LPARAM lpData)
{
	LPITEMIDLIST initialPidl = (LPITEMIDLIST) lpData;

	switch(uMsg)
	{
	case BFFM_INITIALIZED:		// s
		if(initialPidl) {
			// tH_w肷
			::SendMessage(hwnd, BFFM_SETSELECTION, TRUE, lpData);
		}
		break;
	}

	return 0;
}

/////////////////////////////////////////////////////////////////////////////
// \[X擾p
/////////////////////////////////////////////////////////////////////////////

// dll ̃CX^Xnh
HINSTANCE CResourceManager::s_hInstance;
// \[Xp dll ̃CX^Xnh
HINSTANCE CResourceManager::s_hResourceInstance;

//----------------------------------------------------------------------
// 
//----------------------------------------------------------------------

void CResourceManager::Initialize(HINSTANCE hInstance, char* programFolder)
{
	s_hInstance = hInstance;
	s_hResourceInstance = hInstance;

	LANGID langId = GetUserDefaultUILanguage();
	if (!langId) {
		langId = GetUserDefaultLangID();
	}

	if (!langId) {
		return;
	}

	char dllFilepath[MAX_PATH * 4];

	_snprintf(dllFilepath, sizeof(dllFilepath), "%s\\%d\\Resource.dll", programFolder, langId);
	FORCE_ASCIZ(dllFilepath);

	HINSTANCE hResourceInstance = LoadLibrary(dllFilepath);
	if (!hResourceInstance) {
		return;
	}

	s_hResourceInstance = hResourceInstance;
}

//----------------------------------------------------------------------
// 
//----------------------------------------------------------------------

void CResourceManager::Release()
{
	if (s_hInstance != s_hResourceInstance) {
		FreeLibrary(s_hResourceInstance);
	}
}

//----------------------------------------------------------------------
// dll ̃CX^XnhԂ
//----------------------------------------------------------------------
HINSTANCE CResourceManager::GetMainInstance()
{
	return s_hInstance;
}

//----------------------------------------------------------------------
// _CAO\[X[h邽߂̃CX^Xnh𓾂
//----------------------------------------------------------------------

HINSTANCE CResourceManager::GetDialogInstanceHandle(LPCTSTR lpTemplate)
{
	return GetInstanceHandle(lpTemplate, RT_DIALOG);
}

//----------------------------------------------------------------------
// \[XtH[}bgĕԂ
//----------------------------------------------------------------------

std::string CResourceManager::FormatResourceString(UINT uID, ...)
{
	char format[8192] = "";

	va_list args;

	int length = LoadStringResource(uID, format, sizeof(format));
	if (length == 0) {
		format[0] = '\0';
	}
	FORCE_ASCIZ(format);


	char message[8192];

	va_start(args, uID);
	_vsnprintf(message, sizeof(message), format, args);
	FORCE_ASCIZ(message);
	va_end(args);

	return message;
}

//----------------------------------------------------------------------
// [__CAO{bNX쐬
//----------------------------------------------------------------------

INT_PTR CResourceManager::DlgBox(LPCSTR lpTemplateName, HWND hWndParent, DLGPROC lpDialogFunc)
{
	HINSTANCE hInstance = GetDialogInstanceHandle(lpTemplateName);

	return DialogBox(hInstance, lpTemplateName, hWndParent, lpDialogFunc);
}

//----------------------------------------------------------------------
// [hX_CAO{bNX쐬
//----------------------------------------------------------------------

HWND CResourceManager::CreateDlg(LPCSTR lpTemplateName, HWND hWndParent, DLGPROC lpDialogFunc)
{
	HINSTANCE hInstance = GetDialogInstanceHandle(lpTemplateName);

	return CreateDialog(hInstance, lpTemplateName, hWndParent, lpDialogFunc);
}

//----------------------------------------------------------------------
// ACR[h
//----------------------------------------------------------------------

HICON CResourceManager::LoadIconImage(LPCTSTR lpszName, int cxDesired, int cyDesired, UINT fuLoad)
{
	HICON hIcon;
	hIcon = (HICON) LoadImage(s_hResourceInstance, lpszName, IMAGE_ICON, cxDesired, cyDesired, fuLoad);
	if (hIcon) {
		return hIcon;
	}

	return (HICON) LoadImage(s_hInstance, lpszName, IMAGE_ICON, cxDesired, cyDesired, fuLoad);
}

//----------------------------------------------------------------------
// rbg}bv[h
//----------------------------------------------------------------------

HBITMAP CResourceManager::LoadBitmapImage(LPCTSTR lpszName, int cxDesired, int cyDesired, UINT fuLoad)
{
	HBITMAP hBitmap;
	hBitmap = (HBITMAP) LoadImage(s_hResourceInstance, lpszName, IMAGE_BITMAP, cxDesired, cyDesired, fuLoad);
	if (hBitmap) {
		return hBitmap;
	}

	return (HBITMAP) LoadImage(s_hInstance, lpszName, IMAGE_BITMAP, cxDesired, cyDesired, fuLoad);
}

//----------------------------------------------------------------------
// \[XێĂCX^XnhԂ
//----------------------------------------------------------------------

HINSTANCE CResourceManager::GetInstanceHandle(LPCTSTR lpName, LPCTSTR lpType)
{
	HRSRC hRsrc = FindResource(s_hResourceInstance, lpName, lpType);
	if (hRsrc) {
		return s_hResourceInstance;
	}

	return s_hInstance;
}

//----------------------------------------------------------------------
// 񃊃\[X[h
//----------------------------------------------------------------------

int CResourceManager::LoadStringResource(UINT uID, LPSTR lpBuffer, int cchBufferMax)
{
	int length = LoadString(s_hResourceInstance, uID, lpBuffer, cchBufferMax);
	if (length != 0) {
		return length;
	}

	return LoadString(s_hInstance, uID, lpBuffer, cchBufferMax);
}
